//++++++++++++++++++++++++++++++
// FastDDE-Header
// S.Jacobi	(c)1997
//++++++++++++++++++++++++++++++


#define tdtTable	0x0010
#define tdtFloat	0x0001
#define tdtString	0x0002
#define tdtBool		0x0003
#define tdtError	0x0004
#define tdtBlank	0x0005
#define tdtType		0x0080
#define tdtFormat	0x0081


#define maxData 	8000	//Groesse in bytes eines simple_datablocks
#define TIMEOUT 	3000    //default timeout
#define CVT_DIGITS	10		//Anzahl Ziffern bei Konvertieren mit _ecvt()




/////////////////////////////DDEPoke
struct tag_FastDDEMemValues
{
	int rows;
	int columns;
	int offset;				//Offset durch tdtTable und n mal tdtFloat
	int quot;				//Anzahl der maxDataBloecke
	int rem;				//Rest 
	double huge* hPr;    	//Zeiger auf Matrix-Realteil
	BYTE far* hDataBlock;   //Zeiger auf DDE-Datenobjekt (von DdeAccessData() geliefert)
};

typedef struct tag_FastDDEMemValues FastDDEMemValues;

struct tag_PokeFuncParam
{
	DWORD idInst;
	DWORD hConv;
	UINT cbFormat;
	DWORD timeout;
	char* szItem;
    Matrix* Data_Matrix;
};

typedef struct tag_PokeFuncParam PokeFuncParam;




/////////////////////////////DDERequest
struct tag_ReqFuncParam
{
	DWORD idInst;
	DWORD hConv;
	UINT cbFormat;
	DWORD timeout;
	char* szItem;
	Matrix** DestMatrix;
};

typedef struct tag_ReqFuncParam ReqFuncParam;

struct tag_TableHeader
{
    WORD Table;
    WORD cbTable;
    WORD rows;
    WORD columns;
};

typedef struct tag_TableHeader TableHeader;

struct tag_FloatHeader
{
    WORD Float;
    WORD cbFloat;
};

typedef struct tag_FloatHeader FloatHeader;






// Prototypes for DDEPoke
void FastDDEMem( FastDDEMemValues* );
BOOL CFTextPoke( PokeFuncParam* );
BOOL FastDDEPoke( PokeFuncParam* );
int StringConvert( char*, double );


// Prototypes for DDERequest
BOOL FastDDEReq( ReqFuncParam* );
BOOL RemoveHeader( TableHeader*, BYTE huge* );
BOOL CFTextStringReq( ReqFuncParam* );
BOOL CFTextRequest( ReqFuncParam* );
void GetMatrixSize( char huge*, int*, int* );
BOOL Str2Double( double huge*, char huge* );
void Go2Next( char huge*huge* );

// Prototypes for DDEAdvise
BOOL AdvFastDDEReq( HDDEDATA, char* );
BOOL AdvCFTextReq( HDDEDATA, char* );
BOOL AdvCFTextStringReq( HDDEDATA, char* );

// Prototypes for DDEUnadvise
BOOL CallDDEUnadvise( HCONV, HSZ );
